import java.io.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class grohelp extends JFrame implements ListSelectionListener
{
	JSplitPane splitPane;
	JScrollPane left,right;
	String[] commandNames;
	JList commList;
	JTextArea helpText=new JTextArea();
	JLabel helpTitle=new JLabel();
	Font f=new Font("serif",Font.BOLD,20);
	String commandName=null;
	int i=1,cnt=0;
	public grohelp(Container content, Dimension frSize)
	{
		helpTitle.setFont(f);
		helpTitle.setText("Welcome to GUIMACS Command Help Portal");
		try{
			BufferedReader br=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/proglist"));
			while((commandName=br.readLine())!=null)
			{
				cnt++;
			}
			commandNames=new String[cnt+1];
			//commandHelp=new String[cnt+1];
			commandNames[0]="Choose a command";
			//commandHelp[0]="<html>Please select a command from the list to your left for help.</html>";
			//commLabel.setText(commandHelp[0]);
			br.close();
			BufferedReader brw=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/proglist"));
			while((commandName=brw.readLine())!=null)
			{
				commandNames[i]=commandName;
				i++;
			}
			brw.close();
		}
		catch(IOException ioe){System.out.println(ioe);}
		
		commList=new JList(commandNames);
		commList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		commList.setSelectedIndex(0);
		commList.addListSelectionListener(this);
		
		left=new JScrollPane(commList);
		right=new JScrollPane(helpText);
		helpText.setText("Please select a command from the list to your left for help.");
		helpText.setEditable(false);
		
		splitPane=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,true,left,right);
		splitPane.setOneTouchExpandable(true);
		splitPane.setDividerLocation(150);
		
		Dimension minimumSize = new Dimension(100, 50);
		left.setMinimumSize(minimumSize);
		right.setMinimumSize(minimumSize);
		
		content.add(splitPane,BorderLayout.CENTER);
	}
	public void valueChanged(ListSelectionEvent lse)
	{
		if(!lse.getValueIsAdjusting())
		{
			JList theList=(JList)lse.getSource();
			int index=theList.getSelectedIndex();
			if(index==0)
			{
				helpText.setText("Please select a command from the list to your left for help.");
			}
			else
			{
				try{
					String[] runcomm={"/bin/sh","-c",commandNames[index]+" -h 2>/tmp/comm.hlp"};
					Process proc=Runtime.getRuntime().exec(runcomm);
					proc.waitFor();
					BufferedReader br=new BufferedReader(new FileReader("/tmp/comm.hlp"));
					helpText.read(br,null);
					helpText.setFont(new Font("monospaced",Font.PLAIN,14));
					helpText.setMargin(new Insets(10,10,10,10));
				}
				catch(InterruptedException inte)
				{
				}
				catch(FileNotFoundException fnfe)
				{
					JOptionPane.showMessageDialog(this,fnfe,"File Not Found Exception",JOptionPane.ERROR_MESSAGE);
				}
				catch(IOException ioe)
				{
					JOptionPane.showMessageDialog(this,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
				}
			}
		}
			
	}
}
