package vault;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class GroupSelector extends JFrame implements ActionListener
{
	JComboBox jcb1,jcb2;
	int sel1=0,sel2=0;
	String[] grps1,grps2;
	String comm=null,pwd=null;
	InputStreamHandler ish;
	JTextArea jta;
	JLabel l1=new JLabel("Group 1:");
	JLabel l2=new JLabel("Group 2:");
	JPanel p1,p2;
	JButton b;
	public GroupSelector(String[] group1,String[] group2,String command,String pwd)
	{
		setTitle("Select Group");
		this.pwd=pwd;
		comm=command;
		grps1=new String[group1.length];
		grps2=new String[group2.length];
		for(int i=0;i<group1.length;i++)
		{
			grps1[i]=group1[i];
		}
		for(int i=0;i<group2.length;i++)
		{
			grps2[i]=group2[i];
		}
		if(comm.indexOf("g_energy")==-1)
		{
			Container c=getContentPane();
			Box box=Box.createVerticalBox();
			p1=new JPanel(new FlowLayout());
			p2=new JPanel(new FlowLayout());
			c.add(box);
			jcb1=new JComboBox(group1);
			jcb2=new JComboBox(group2);
			if(command.indexOf("g_gyrate")!=-1)
			{
				jcb2.setEnabled(false);
			}
			p1.add(l1);
			p2.add(l2);
			p1.add(jcb1);
			p2.add(jcb2);
			b=new JButton("Select");
			b.addActionListener(this);
			box.add(p1);
			box.add(p2);
			box.add(b);
			pack();
		}
	}
	public void actionPerformed(ActionEvent ae)
	{
		String grp1=jcb1.getSelectedItem().toString();
		String grp2=jcb2.getSelectedItem().toString();
		for(int i=0;i<grps1.length;i++)
		{
			if(grps1[i].equals(grp1))
			{
				sel1=i;
				break;
			}
		}
		for(int i=0;i<grps2.length;i++)
		{
			if(grps2[i].equals(grp2))
			{
				sel2=i;
				break;
			}
		}
		if(comm.indexOf("g_rms")!=-1 || comm.indexOf("g_confrms")!=-1 || comm.indexOf("g_hbond")!=-1)
		{
			try{
				BufferedWriter bw=new BufferedWriter(new FileWriter("/tmp/exec.exp"));
				bw.write("#!/bin/expect\n");
				bw.write("spawn -noecho "+comm+"\n");
				bw.write("expect \"Select a group: \"\n");
				bw.write("send \""+sel1+"\\r\"\n");
				bw.write("expect \"Select a group: \"\n");
				bw.write("send \""+sel2+"\\r\"\n");
				bw.write("set timeout -1\n");
				bw.write("expect EOF");
				bw.close();
			}
			catch(IOException ioe)
			{
				JOptionPane.showMessageDialog(null,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
			}
		}
		if(comm.indexOf("g_gyrate")!=-1)
		{
			try{
				BufferedWriter bw=new BufferedWriter(new FileWriter("/tmp/exec.exp"));
				bw.write("#!/bin/expect\n");
				bw.write("spawn -noecho "+comm+"\n");
				bw.write("expect \"Select a group: \"\n");
				bw.write("send \""+sel1+"\\r\"\n");
				bw.write("set timeout -1\n");
				bw.write("expect EOF");
				bw.close();
			}
			catch(IOException ioe)
			{
				JOptionPane.showMessageDialog(null,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
			}
		}
		this.hide();
		Thread runner=new Thread()
		{
			public void run()
			{
				try{
					String[] runcomm={"/bin/sh","-c","expect /tmp/exec.exp > command.log"};
					Process proc=Runtime.getRuntime().exec(runcomm,null,(new File(pwd)));
					JOptionPane.showMessageDialog(null,"Process started.\nPlease wait until it finishes.\nYou will be notified with a similar dialog when the process finishes execution.","Started...",JOptionPane.INFORMATION_MESSAGE);
					int rv=proc.waitFor();
					JOptionPane.showMessageDialog(null,"Finished execution.\nIt is highly recommended that you verify the log file.\n\n"+pwd+"/command.log - output log","Done",JOptionPane.INFORMATION_MESSAGE);
				}
				catch(IOException ioe)
				{
					JOptionPane.showMessageDialog(null,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
				}
				catch(InterruptedException inte)
				{
					JOptionPane.showMessageDialog(null,inte,"Interrupted Exception",JOptionPane.ERROR_MESSAGE);
				}
			}
		};
		runner.start();
	}
}
